

#include <Firmata.h>

#define DATAMODETEXT 1
#define MAINSERIAL Serial
//#define SECSERIAl Serial2


void setup()
{
  PORTH = 0x60;
  DDRH = 0x03;  //Digital pins 8-9.
  PORTB = 0x30;
  DDRB = 0x30;  //Digital pins 10-11
  PORTF = 0x01;
  DDRF = 0x01; //Analog Pin 0
  //SECSERIAL.begin(115200);
  MAINSERIAL.begin(115200);
  MAINSERIAL.println("SPC700 DATA LOADER V1.0, DEBUGGING");
}


unsigned char readdata(unsigned char address)
{
  unsigned char data;

  DDRB = 0x30;    //APU RD/WR
  DDRH = 0x60;    //APU A0-A1
  DDRB &= ~0xC0;  //APU D0-D1
  DDRE &= ~0x38;  //APU D2-D3, D5
  DDRG &= ~0x20;  //APU D4
  DDRH &= ~0x18;  //APU D6-D7
  PORTH &= ~0x60;
  PORTH |= ((address & 0x03)<<5);

  PORTB &= ~0x10;
  __asm__ __volatile__ ("nop");
  __asm__ __volatile__ ("nop");
  data=((PINB&0xC0)>>6) | ((PINE&0x30)>>2) | ((PING&0x20)>>1) | ((PINE&0x08)<<2) | ((PINH&0x18)<<3);
  PORTB |= 0x10;
  return data;
}

void writedata(unsigned char address, unsigned char data)
{
  DDRB = 0xF0;
  DDRE |= 0x38;
  DDRG |= 0x20;
  DDRH |= 0x18;

  PORTB &= ~0xC0;
  PORTB |= ((data & 0x03)<<6);
  
  PORTE &= ~0x38;
  PORTE |= ((data & 0x0C)<<2);
  
  PORTG &= ~0x20;
  PORTG |= ((data&0x10)<<1);
  
  PORTE |= ((data & 0x20)>>2);
  
  PORTH &= ~0x78;
  PORTH |= ((address & 0x03)<<5);
  PORTH |= ((data&0xC0)>>3);
  
  PORTB &= ~0x20;
  __asm__ __volatile__ ("nop");
  __asm__ __volatile__ ("nop");
  PORTB |= 0x20;

}


#ifdef DATAMODETEXT
int datamode=0;
#endif

#define DEBUGGING 0
#define DEBUG(x)  if (DEBUGGING) { x; }



/* IO Pin Mapping.
 ** Digital Pin 0 - RX
 ** Digital Pin 1 - TX
 ** Digital Pin 2-7 - SNES APU D2-7
 ** Digital Pin 8 - SNES APU address 0
 ** Digital Pin 9 - SNES APU address 1
 ** Digital Pin 10 - SNES APU /RD
 ** Digital Pin 11 - SNES APU /WR
 ** Digital Pin 12-13 - SNES APU D0-1
 ** Analog Pin 0 (AKA Digital Pin 54) - SNES APU /RESET
 ** Vcc - SNES APU address 6, SNES APU Vcc, SNES APU audio Vcc
 ** Gnd - SNES APU Gnd, SNES APU audio Gnd.
 */

unsigned char port0state;



/*
unsigned char program_counter=0xFF;
 uint32_t delay_count=0;
 unsigned char Script700[64];
 unsigned char Script700WorkArea[8];
 unsigned char Script700RAM[64];*/
 
 void printbyte2(uint8_t data)
{
 // if(data<16)
 //   SECSERIAL.print(0,HEX);
 // SECSERIAL.print(data,HEX);
}

void printbyte(uint8_t data)
{
  if(data<16)
    MAINSERIAL.print(0,HEX);
  MAINSERIAL.print(data,HEX);
}

void printbyte2ln(uint8_t data)
{
  //if(data<16)
  //  SECSERIAL.print(0,HEX);
  //SECSERIAL.println(data,HEX);
}

void printbyteln(uint8_t data)
{
  if(data<16)
    MAINSERIAL.print(0,HEX);
  MAINSERIAL.println(data,HEX);
}

void ProcessScript700()
{
  // --- TODO:  Implement script 700 processing, and script700 uploading procedures.
  // --- Limitations.  Only ~512 bytes of working ram/code space to work with.
  // --- No direct access to the APU ram/registers in any way, shape or form,
  // --- other than IO ports F4-F7.
  /*
  if(program_counter==0xFF)
   return;
   
   if(delay_count)
   {
   if(delay_count>=32)
   {
   delay_count-=32;
   delayMicroseconds(16);
   }
   else
   {
   delayMicroseconds(delay_count>>1);
   delay_count=0;
   }
   return;
   }
   
   switch(Script700[program_counter&0x3F]&0x0F)
   {
   case 0:  //Wait
   delay_count = Script700[program_counter+1];
   delay_count |= Script700[program_counter+2]<<8;
   delay_count |= Script700[program_counter+1] << 16;
   delay_count |= Script700[program_counter+1] << 24;
   program_counter+=5;
   break;
   case 1:  //Move
   break;
   default:
   program_counter=0xFF;
   break;
   }*/

}

unsigned char serial2command;

unsigned char readserial()
{
  while ((MAINSERIAL.available() == 0))
    ProcessScript700();
  /*if(SECSERIAL.available())
  {
    if(serial2command==1)
      return readhex();
    else
      return SECSERIAL.read();
  }
  else
  {
    return MAINSERIAL.read();
  }*/
  return MAINSERIAL.read();
}


unsigned char readhex()
{
  unsigned char data[2];
  serial2command = 0;
  data[0]=readserial();
  data[1]=readserial();
  serial2command = 1;
  if((data[0]>='0')&&(data[0]<='9'))
    data[0]-='0';
  else if ((data[0]>='A')&&(data[0]<='F'))
  {
    data[0]-='A';
    data[0]+=10;
  }
  else if ((data[0]>='a')&&(data[0]<='f'))
  {
    data[0]-='a';
    data[0]+=10;
  }
  else
    data[0]=0;

  if((data[1]>='0')&&(data[1]<='9'))
    data[1]-='0';
  else if ((data[1]>='A')&&(data[1]<='F'))
  {
    data[1]-='A';
    data[1]+=10;
  }
  else if ((data[1]>='a')&&(data[1]<='f'))
  {
    data[1]-='a';
    data[1]+=10;
  }
  else
    data[1]=0;

  return (data[0]<<4)|data[1];
}


void startapuwrite(uint16_t address, unsigned char *data, int len, int continue_write)
{
  int i;
  uint8_t rdata;
  digitalWrite(54,LOW);
  delay(1);
  digitalWrite(54,HIGH);

  if(!continue_write)
  {
    while(readdata(0)!=0xAA);
    while(readdata(1)!=0xBB);
  }
  else
  {
    rdata=readdata(0);
    rdata+=2;
  }

  writedata(3,address>>8);
  writedata(2,address&0xFF);
  writedata(1,1);
  if(!continue_write)
  {
    writedata(0,0xCC);
    while(readdata(0)!=0xCC);
  }
  else
  {
    writedata(0,rdata);
    while(readdata(0)!=rdata);
  }
  for(i=0;i<len;i++)
  {
    writedata(1,data[i]);
    writedata(0,i&0xFF);
    while(readdata(0)!=(i&0xFF));
  }
}

/* // --- Implemented for faster emulator linking, on at least the initial code upload.
 // The code will be skipped by usual fashion, but data recorded for to do the initial upload.
 // Once the data is uploaded, all 8/16 bit read/writes will be passed on to the emulator to control.
 // startapuwrite is not commented out, because it is being used for spc file uploading process.
 void continueapuwrite(uint16_t address, unsigned char *data, int len)
 {
 int i;
 i=readdata(0);
 i+=2;
 writedata(3,address>>8);
 writedata(2,address&0xFF);
 writedata(1,1);
 writedata(0,i&0xFF);
 while(readdata(0)!=(i&0xFF));
 for(i=0;i<len;i++)
 {
 writedata(1,data[i]);
 writedata(0,i&0xFF);
 while(readdata(0)!=(i&0xFF));
 }
 }
 
 void executeapu(uint16_t address)
 {
 int i;
 i=readdata(0);
 i+=2;
 writedata(3,address>>8);
 writedata(2,address&0xFF);
 writedata(1,1);
 writedata(0,i&0xFF);
 //while(readdata(0)!=(i&0xFF)); //Commented just in case executed code clears the i+2 result immediately.
 }*/

void APU_Wait(unsigned char address, unsigned char data)
{
  while(readdata(address)!=data);
}

unsigned char DSPdata[16] =
{  //For loading the 128 byte DSP ram. DO NOT CHANGE.
  0xC4, 0xF2, 0x64, 0xF4, 0xD0, 0xFC, 0xFA, 0xF5, 0xF3, 0xC4, 0xF4, 0xBC, 0x10, 0xF2, 0x2F, 0xB7, 
};

unsigned char nopatchloader[9] = 
{ //For doing the final loading via the IO ports.
// The arduion is NOT fast enough to do it directly, so we have to upload a very tiny program
// to get this started.  It consists of
// mov A, #0xFE
// cmp A, [0xF7]
// bne -4
// jmp 0xF6
  0xE8, 0xFE, 0x64, 0xF7, 0xD0, 0xFC, 0x5F, 0xF6, 0x00
};

int wait_io_port(uint8_t address, uint8_t data, int timeout)
{
  int i=0;
  while((readdata(address)!=data)&&(i<timeout)) i++;
  if(i<timeout)
    return 0;
  return 1;
}

uint8_t spctransfer;
  
void loop()
{
  uint16_t i;
  static uint16_t j;
  static long time;
  int checksum;
  unsigned char address, data;
  serial2command = 0;
  unsigned char command = readserial();
  serial2command = 1;
  if(command == 'Q') {
    j++;
    //if(!(j%2048)) {
    //  SECSERIAL.print(byte(command));
    //  SECSERIAL.print(" - ");
    //}
  }
  //else
  //{
  //  SECSERIAL.print(byte(command));
  //  SECSERIAL.print(" - ");
  //}
  switch(command)
  {
  case 'D':    //Set datamode between ascii and binary.  In ascii mode,  each data byte is transmitted
    //as ascii hexadecimal notation.  In binary mode, the byte transmitted on the serial
    //line is taken literally for what it is.
#ifdef DATAMODETEXT
    datamode=readserial()-'0';
    if(datamode)
    {
      MAINSERIAL.println("Data mode set to Text");
      //SECSERIAL.println("Data mode set to Text");
    }
    //else
    //{
    //  SECSERIAL.println("Data mode set to binary");
    //}
      
#else
     //Ignore this byte, but keep it here anyways.
    if((readserial()-'0'))
    {
      //MAINSERIAL.println("Data mode text not compiled in, still in binary mode");
      //SECSERIAL.println("Data mode text not compiled in, still in binary mode");
    }
    //else
    //{
    //  SECSERIAL.println("Data mode set to binary");
    //}
#endif
    
    break;


  case 'Q':  //Read all 4 IO ports in rapid fire succession.
#ifdef DATAMODETEXT
    if(!datamode)
    {
#endif
      //if(!(j%2048)) SECSERIAL.print("Data on All 4 ports = ");
      data=readdata(0);
      MAINSERIAL.write(data);
      //if(!(j%2048)) printbyte2(data);
      data=readdata(1);
      MAINSERIAL.write(data);
      //if(!(j%2048)) printbyte2(data);
      data=readdata(2);
      MAINSERIAL.write(data);
      //if(!(j%2048)) printbyte2(data);
      data=readdata(3);
      MAINSERIAL.write(data);
      //if(!(j%2048)) printbyte2ln(data);
#ifdef DATAMODETEXT
    }
    else
    {
      MAINSERIAL.print("Data on All 4 ports = ");
      data=readdata(0);
      printbyte(data);
      data=readdata(1);
      printbyte(data);
      data=readdata(2);
      printbyte(data);
      data=readdata(3);
      printbyteln(data);
    }
#endif
    break;
  case 'R':  //Read a single IO port.  Takes an address as a parameter, returns one byte.
    address=readserial()-'0';
    data=readdata(address);
#ifdef DATAMODETEXT
    if(datamode)
    {
      MAINSERIAL.print("Data at Address ");
      MAINSERIAL.print(address,DEC);
      MAINSERIAL.print(" is ");
      printbyteln(data);
    }
    else
#endif
      MAINSERIAL.write(data);
      //SECSERIAL.print("Data at Address ");
      //SECSERIAL.print(address,DEC);
      //SECSERIAL.print(" is ");
      printbyte2ln(data);
    break;
  case 'r':  //Read and returns 2 consecutive IO ports.
    address=readserial()-'0';
    data=readdata(address+1);
#ifdef DATAMODETEXT
    if(datamode)
    {
      MAINSERIAL.print("Data at Address ");
      MAINSERIAL.print(address,DEC);
      MAINSERIAL.print(" is ");
      printbyte(data);
      data=readdata(address);
      printbyteln(data);
    }
    else
    {
#endif
      //SECSERIAL.print("Data at Address ");
      //SECSERIAL.print(address,DEC);
      //SECSERIAL.print(" is ");
      //printbyte2(data);
      MAINSERIAL.write(data);
      data=readdata(address);
      //printbyte2ln(data);
      MAINSERIAL.write(data);
#ifdef DATAMODETEXT
    }
#endif
    break; 
  case 'S':
    MAINSERIAL.println("SPC700 DATA LOADER V1.0");
    //SECSERIAL.println("SPC700 DATA LOADER V1.0");
    break;
  case 's':  //Reset the Audio Processing Unit
#ifdef DATAMODETEXT
    if(datamode)
      MAINSERIAL.println("APU Reset");
#endif
    //SECSERIAL.println("APU Reset");
    //Try the Analog line first.
    digitalWrite(54,LOW);
    delay(1);
    digitalWrite(54,HIGH);
    if(readdata(0)!=0xAA)  //Check for reset.
    {
      //And now try the OR gate, just in case the user has that hooked up instead.
      digitalWrite(10,LOW);
      digitalWrite(11,LOW);
      delay(1);
      digitalWrite(11,HIGH);
      digitalWrite(10,HIGH);
    }
    break;
  case 'f':  //Set the expected state of PORT 0 for the next write.
    port0state=readserial();
    //SECSERIAL.print("Expected Port 0 state set to ");
    //printbyte2ln(port0state);
    break;
  case 'F':  //Upload SPC data at serial port speed.
    uint16_t ram_addr;
    uint16_t data_size;
    /*
    writedata(1,1);
    writedata(2,0);
    writedata(3,1);
    i=readdata(0);
    i+=2;
    writedata(0,i);
    while(readdata(0)!=i);
    port0state=0;
    */
    
    ram_addr=readserial()<<8;
    ram_addr|=readserial();
    
    //SECSERIAL.print("Ram Address = ");
    //SECSERIAL.print(ram_addr,HEX);
    data_size=readserial()<<8;
    data_size|=readserial();
    //SECSERIAL.print(", Data Size = ");
    //SECSERIAL.println(data_size,HEX);
    writedata(1,1);
    writedata(2,ram_addr&0xFF);
    writedata(3,ram_addr>>8);
    i=readdata(0);
    i+=2;
    writedata(0,i&0xFF);
    while(readdata(0)!=(i&0xFF));
    port0state=0;
    //SECSERIAL.println("SPC Data Transfer Started");
    for(i=0;i<data_size;i++)
    //for(i=0;i<65280;i++)
    {
      /*if(!(i%16))
      {
        SECSERIAL.print(".");
      }*/
      //data=i&0xFF;
      data=readserial();
      writedata(1,data);
      writedata(0,port0state);
      //while(readdata(0)!=port0state);
      port0state++;
      //SECSERIAL.print("Received byte:");
      //SECSERIAL.println(data,HEX);
    }
    //SECSERIAL.print(millis()-time,DEC);
    //SECSERIAL.println(" milliseconds to upload SPC");
    ////SECSERIAL.println("Transfer Finished");
    MAINSERIAL.write(1);

    break;

  case 'G':  //Upload the DSP register, and the first page of SPC data at serial port speed.
    //SECSERIAL.println("START");
    time=millis();
    spctransfer = 1;
    //SECSERIAL.println("DSP Data Transfer started");
    startapuwrite(0x0002,DSPdata,16,0);
    writedata(2,0x02);
    writedata(3,0x00);
    writedata(1,0x00);
    writedata(0,0x11);
    while(readdata(0)!=0x11);
    port0state=0;
    for(i=0;i<128;i++)
    {
      data=readserial();
      writedata(1,data);
      writedata(0,port0state);
      //if(i<127)
      //  while(readdata(0)!=port0state);
      port0state++;
    }
    while(readdata(0)!=0xAA);
    port0state=0;
    writedata(2,0x02);
    writedata(3,0x00);
    writedata(1,0x01);
    writedata(0,0xCC);
    while(readdata(0)!=0xCC);
    for(i=0;i<256;i++)
    {
      data=readserial();
      if(i<2)
        continue;
      if(i>=0xF0)
        continue;
      writedata(1,data);
      writedata(0,port0state);
      //while(readdata(0)!=port0state);
      port0state++;
    }
    MAINSERIAL.write('F');
    //SECSERIAL.println("Transfer Finished");
    break;
  case 'W':  //Write a single IO port.
    address=readserial()-'0';
#ifdef DATAMODETEXT
    if(datamode)
      data=readhex();
    else
#endif
      data=readserial();
      i=0;  //Must timeout any wait loops, if the respective drivers are not running.
    switch(address-4)
    {
      case 0:
        
        while((readdata(1)!=((readdata(0)+1)&0xFF))&&(i<128)) i++;  //Handle a blazeon track change.
        if(i<128)
        {
          writedata(0,data);
          //SECSERIAL.print("Wrote Song: ");
          //printbyte2(data); 
          //SECSERIAL.println(" to Blazeon Driver");
        }
        /*else
        {
          SECSERIAL.println("Blazeon Driver is NOT running");
        }*/
        /*
        ** Blazeon uses the following port communication system.
        ** When Port 1 is Equal to Port 0 + 1, then it is safe to write a new value to any of the 4 ports.
        ** When Port 0 is Equal to Port 1 + 1, then the SPC side driver is reading the ports, then clearing
        ** the ports.  As a result, if we write during the latter time, it ends up being a race condition to
        ** get the write in the specific port, before that port is read out.
        ** Immediately following the readout of the ports, the in ports are automatically cleared and will read
        ** as 0 on SPC side.
        **
        ** There is absolutely no SPC reloading code stored in a Blazeon SPC.  Once it is running, it runs forever,
        ** with its preprogrammed songs/sfxs. Writing to any port changes songs/sfxs played instantly during the
        ** former condition.
        */
        break;
      case 1:  //Multiple games use this song select driver.
        writedata(1,data);
        //SECSERIAL.print("Wrote Song: ");
        //printbyte2(data); 
        //SECSERIAL.println(" to Driver type #1");
        writedata(0,3);
        data=readdata(3);
        data++;
        writedata(3,data);
        if(wait_io_port(3,data,2048))
          break;
        i = 0;
        //SECSERIAL.println("Driver song stopped");
        writedata(0,4);
        data=readdata(3);
        data++;
        writedata(3,data);
        if(wait_io_port(3,data,2048))
          break;
        //SECSERIAL.print("Driver song started");
        writedata(0,0);
        break;
      case 2:
        writedata(3,data);
        //SECSERIAL.print("Wrote Song: ");
        //printbyte2(data); 
        //SECSERIAL.println(" to Driver type #2");
        writedata(0,0x80);
        if(wait_io_port(0,0,2048))
          break;
        writedata(0,0);
        break;
      case 0xFC:  //0 - 4 = 0xFC.
      case 0xFD:  //1 - 4 = 0xFD.
      case 0xFE:  //2 - 4
      case 0xFF:  //3 - 4
      default:    //Any other driver selection not put here.
        /*
        ** Default, is just write the ports as is.
        */
        writedata(address,data);
#ifdef DATAMODETEXT
        if(datamode)
        {
          MAINSERIAL.print("Writing 8bit ");
          if(data<16)
            MAINSERIAL.print(0,HEX);
          MAINSERIAL.print(data,HEX);
          MAINSERIAL.print(" to address ");
          MAINSERIAL.println(address,DEC);
        }
#endif
        //SECSERIAL.print("Writing 8bit ");
        //printbyte2(data);
        //SECSERIAL.print(" to address ");
        //SECSERIAL.println(address,DEC);
        if(spctransfer)
        {
          spctransfer++;
          if(spctransfer>8)
          {
            spctransfer = 0;
            //SECSERIAL.print(millis()-time,DEC);
            //SECSERIAL.println(" milliseconds to upload SPC");
          }
        }
    }
    break;
  case 'w':  //Write 2 IO consecutive IO ports.
    address=readserial()-'0';
#ifdef DATAMODETEXT
    if(!datamode)
    {
#endif
      data=readserial();
      writedata(address+1,data);
      //SECSERIAL.print("Writing 16bit ");
      printbyte2(data);
      data=readserial();
      writedata(address,data);
      //SECSERIAL.print(" ");
      printbyte2(data);
      //SECSERIAL.print(" to address ");
      //SECSERIAL.println(address,DEC);
#ifdef DATAMODETEXT
    }
    else
    {
      data=readhex();
      writedata(address+1,data);
      MAINSERIAL.print("Writing 16bit ");
      printbyte(data);
      data=readhex();
      writedata(address,data);
      MAINSERIAL.print(" ");
      printbyte(data);
      MAINSERIAL.print(" to address ");
      MAINSERIAL.println(address,DEC);
    }
#endif
    break;
    //default:
      //SECSERIAL.println("Invalid command");
  }
}
